/*
---------------------------------------------------------------------------
 $Id: tsp_lease.c,v 1.7 2006/11/01 15:16:32 dgregoire Exp $
---------------------------------------------------------------------------
Copyright (c) 2001-2006 Hexago Inc. All rights reserved.

  LICENSE NOTICE: You may use and modify this source code only if you
  have executed a valid license agreement with Hexago Inc. granting
  you the right to do so, the said license agreement governing such
  use and modifications.   Copyright or other intellectual property
  notices are not to be removed from the source code.
---------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define _USES_SYS_TIME_H_

#include "platform.h"
#include "lib.h"
#include "log.h"
#include "hex_strings.h"
#include "errors.h"

#ifdef V4V6_SUPPORT

/*
 * This function verify if expiration time is reached.
 */
int
tspLeaseCheck(int expiration)
{
	struct timeval tv;

	/* get current time */
	GETTIMEOFDAY(&tv, NULL);

	/* if expired, return 1 */
	if (tv.tv_sec > expiration)
		return 1;

	else return 0;
}

/*
 * This function calculate expiration time and loop
 * until we reach it.
 */
int
tspLeaseLoop(int lifetime)
{
	struct timeval tv;
	int expiration;

	/* get current time */
	GETTIMEOFDAY(&tv, NULL);
	/* calculate expiration time */
	expiration = tv.tv_sec + lifetime;

	Display(LOG_LEVEL_3, ELInfo, "tspLeaseLoop", HEX_STR_SLEEPING_FOR_ALLOC_LEASE);
	
	/* loop until expiration */
	for (;;) {
		SLEEP(1);
		if (tspLeaseCheck(expiration) == 1)
			return LEASE_EXPIRED;
	}

	/* should never reach here */
	return 0;
}

#endif /* V4V6_SUPPORT */
